com.dlsc.flexgantt.swing

## Class GanttChartInternalFrame<T extends AbstractGanttChart>

- java.lang.Object
- - java.awt.Component
  - - java.awt.Container
    - - javax.swing.JComponent
      - - javax.swing.JInternalFrame
        - - com.dlsc.flexgantt.swing.GanttChartInternalFrame<T>

- Type Parameters:
    `T` - the Gantt chart type (see `GanttChart`, `DualGanttChart`).
  All Implemented Interfaces:
    ImageObserver, MenuContainer, Serializable, Accessible, RootPaneContainer, WindowConstants

      public class GanttChartInternalFrame<T extends AbstractGanttChart>
      extends JInternalFrame

  An internal frame implementation specifically designed for use with a Gantt chart. The frame adds a `GanttChartGlassPane` as a glass pane to itself. The panel will be used to block user input whenever the Gantt chart is busy (that is usually while a command gets executed).
  Since:
    1.0
  Version:
    $Revision: 1.4 $
  Author:
    Dirk Lemmermann
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class javax.swing.JInternalFrame

      `JInternalFrame.AccessibleJInternalFrame, JInternalFrame.JDesktopIcon`

    - ### Nested classes/interfaces inherited from class javax.swing.JComponent

      `JComponent.AccessibleJComponent`

    - ### Nested classes/interfaces inherited from class java.awt.Container

      `Container.AccessibleAWTContainer`

    - ### Nested classes/interfaces inherited from class java.awt.Component

      `Component.AccessibleAWTComponent, Component.BaselineResizeBehavior, Component.BltBufferStrategy, Component.FlipBufferStrategy`

  - ### Field Summary

    - ### Fields inherited from class javax.swing.JInternalFrame

      `closable, CONTENT_PANE_PROPERTY, desktopIcon, FRAME_ICON_PROPERTY, frameIcon, GLASS_PANE_PROPERTY, iconable, IS_CLOSED_PROPERTY, IS_ICON_PROPERTY, IS_MAXIMUM_PROPERTY, IS_SELECTED_PROPERTY, isClosed, isIcon, isMaximum, isSelected, LAYERED_PANE_PROPERTY, maximizable, MENU_BAR_PROPERTY, resizable, ROOT_PANE_PROPERTY, rootPane, rootPaneCheckingEnabled, title, TITLE_PROPERTY`

    - ### Fields inherited from class javax.swing.JComponent

      `listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

    - ### Fields inherited from class java.awt.Component

      `accessibleContext, BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

    - ### Fields inherited from interface javax.swing.WindowConstants

      `DISPOSE_ON_CLOSE, DO_NOTHING_ON_CLOSE, EXIT_ON_CLOSE, HIDE_ON_CLOSE`

    - ### Fields inherited from interface java.awt.image.ImageObserver

      `ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `GanttChartInternalFrame(String title, T gc)` Constructs a new internal frame and adds the given Gantt chart, a toolbar, a status bar and a glass pane.
    `GanttChartInternalFrame(String title, T gc, boolean resizable)` Constructs a new internal frame and adds the given Gantt chart, a toolbar, a status bar and a glass pane.
    `GanttChartInternalFrame(String title, T gc, boolean resizable, boolean closable)` Constructs a new internal frame and adds the given Gantt chart, a toolbar, a status bar and a glass pane.
    `GanttChartInternalFrame(String title, T gc, boolean resizable, boolean closable, boolean maximizable)` Constructs a new internal frame and adds the given Gantt chart, a toolbar, a status bar and a glass pane.
    `GanttChartInternalFrame(String title, T gc, boolean resizable, boolean closable, boolean maximizable, boolean iconifiable)` Constructs a new internal frame and adds the given Gantt chart, a toolbar, a status bar and a glass pane.
    `GanttChartInternalFrame(T gc)` Constructs a new internal frame and adds the given Gantt chart, a toolbar, a status bar and a glass pane.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `createContent(T gc)` Performs the actual creation of the frame's content.
    `protected GanttChartStatusBar` | `createStatusBar(T gc)` Creates a specialized statusbar for the given Gantt chart.
    `protected GanttChartToolBar` | `createToolBar(T gc)` Creates a specialized toolbar for the given Gantt chart.
    `T` | `getGanttChart()` Returns the Gantt chart that is displayed inside the frame.
    `GanttChartStatusBar` | `getStatusBar()` Returns the statusbar used for showing Gantt chart specific properties and status information.
    `GanttChartToolBar` | `getToolBar()` Returns the toolbar used for displaying the Gantt chart's actions.

    - ### Methods inherited from class javax.swing.JInternalFrame

      `addImpl, addInternalFrameListener, createRootPane, dispose, doDefaultCloseAction, fireInternalFrameEvent, getAccessibleContext, getContentPane, getDefaultCloseOperation, getDesktopIcon, getDesktopPane, getFocusCycleRootAncestor, getFocusOwner, getFrameIcon, getGlassPane, getInternalFrameListeners, getJMenuBar, getLastCursor, getLayer, getLayeredPane, getMenuBar, getMostRecentFocusOwner, getNormalBounds, getRootPane, getTitle, getUI, getUIClassID, getWarningString, hide, isClosable, isClosed, isFocusCycleRoot, isIcon, isIconifiable, isMaximizable, isMaximum, isResizable, isRootPaneCheckingEnabled, isSelected, moveToBack, moveToFront, pack, paintComponent, paramString, remove, removeInternalFrameListener, reshape, restoreSubcomponentFocus, setClosable, setClosed, setContentPane, setCursor, setDefaultCloseOperation, setDesktopIcon, setFocusCycleRoot, setFrameIcon, setGlassPane, setIcon, setIconifiable, setJMenuBar, setLayer, setLayer, setLayeredPane, setLayout, setMaximizable, setMaximum, setMenuBar, setNormalBounds, setResizable, setRootPane, setRootPaneCheckingEnabled, setSelected, setTitle, setUI, show, toBack, toFront, updateUI`

    - ### Methods inherited from class javax.swing.JComponent

      `addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingOrigin, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintImmediately, paintImmediately, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

    - ### Methods inherited from class java.awt.Container

      `add, add, add, add, add, addContainerListener, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, transferFocusDownCycle, validate, validateTree`

    - ### Methods inherited from class java.awt.Component

      `action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, resize, resize, setBounds, setBounds, setComponentOrientation, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setName, setSize, setSize, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### GanttChartInternalFrame

          public GanttChartInternalFrame(T gc)

      Constructs a new internal frame and adds the given Gantt chart, a toolbar, a status bar and a glass pane.
      Parameters:
        `gc` - the Gantt chart that is displayed in the frame
      Since:
        1.0
      See Also:
        `createContent(AbstractGanttChart)`

    - #### GanttChartInternalFrame

          public GanttChartInternalFrame(String title,
                                         T gc)

      Constructs a new internal frame and adds the given Gantt chart, a toolbar, a status bar and a glass pane.
      Parameters:
        `title` - the frame's title
        `gc` - the Gantt chart that is displayed in the frame
      Since:
        1.0
      See Also:
        `createContent(AbstractGanttChart)`

    - #### GanttChartInternalFrame

          public GanttChartInternalFrame(String title,
                                         T gc,
                                         boolean resizable)

      Constructs a new internal frame and adds the given Gantt chart, a toolbar, a status bar and a glass pane.
      Parameters:
        `title` - the frame's title
        `gc` - the Gantt chart that is displayed in the frame
        `resizable` - determines whether the frame can be resized or not
      Since:
        1.0
      See Also:
        `createContent(AbstractGanttChart)`

    - #### GanttChartInternalFrame

          public GanttChartInternalFrame(String title,
                                         T gc,
                                         boolean resizable,
                                         boolean closable)

      Constructs a new internal frame and adds the given Gantt chart, a toolbar, a status bar and a glass pane.
      Parameters:
        `title` - the frame's title
        `gc` - the Gantt chart that is displayed in the frame
        `resizable` - determines whether the frame can be resized or not
        `closable` - determines whether the frame can be closed or not
      Since:
        1.0
      See Also:
        `createContent(AbstractGanttChart)`

    - #### GanttChartInternalFrame

          public GanttChartInternalFrame(String title,
                                         T gc,
                                         boolean resizable,
                                         boolean closable,
                                         boolean maximizable)

      Constructs a new internal frame and adds the given Gantt chart, a toolbar, a status bar and a glass pane.
      Parameters:
        `title` - the frame's title
        `gc` - the Gantt chart that is displayed in the frame
        `resizable` - determines whether the frame can be resized or not
        `closable` - determines whether the frame can be closed or not
        `maximizable` - determines whether the frame can be maximized or not
      Since:
        1.0
      See Also:
        `createContent(AbstractGanttChart)`

    - #### GanttChartInternalFrame

          public GanttChartInternalFrame(String title,
                                         T gc,
                                         boolean resizable,
                                         boolean closable,
                                         boolean maximizable,
                                         boolean iconifiable)

      Constructs a new internal frame and adds the given Gantt chart, a toolbar, a status bar and a glass pane.
      Parameters:
        `title` - the frame's title
        `gc` - the Gantt chart that is displayed in the frame
        `resizable` - determines whether the frame can be resized or not
        `closable` - determines whether the frame can be closed or not
        `maximizable` - determines whether the frame can be maximized or not
        `iconifiable` - determines whether the frame can be iconified or not
      Since:
        1.0
      See Also:
        `createContent(AbstractGanttChart)`

  - ### Method Detail

    - #### createContent

          protected void createContent(T gc)

      Performs the actual creation of the frame's content.
      Parameters:
        `gc` - the frame's main component, the Gantt chart
      Since:
        1.0

    - #### getGanttChart

          public T getGanttChart()

      Returns the Gantt chart that is displayed inside the frame.
      Returns:
        the frame's main component, the Gantt chart.
      Since:
        1.0

    - #### getStatusBar

          public GanttChartStatusBar getStatusBar()

      Returns the statusbar used for showing Gantt chart specific properties and status information.
      Returns:
        the frame's statusbar
      Since:
        1.0

    - #### getToolBar

          public GanttChartToolBar getToolBar()

      Returns the toolbar used for displaying the Gantt chart's actions.
      Returns:
        the frame's toolbar
      Since:
        1.0

    - #### createToolBar

          protected GanttChartToolBar createToolBar(T gc)

      Creates a specialized toolbar for the given Gantt chart.
      Parameters:
        `gc` - the Gantt chart that will be controlled by the toolbar
      Returns:
        a toolbar for the given Gantt chart
      Since:
        1.0

    - #### createStatusBar

          protected GanttChartStatusBar createStatusBar(T gc)

      Creates a specialized statusbar for the given Gantt chart.
      Parameters:
        `gc` - the Gantt chart for which information will be displayed in the status bar
      Returns:
        a statusbar for the given Gantt chart
      Since:
        1.0

Copyright © 2006–2020 Dirk Lemmermann Software & Consulting. All rights reserved.